<?php

//-------------------------------------------------------------
//
// $Id: mutant.php,v 1.19 2004/04/05 06:36:37 kuatodotorg Exp $
//
// STARTED   : 02/04/2004
// COPYRIGHT : 2002-2004 kuato.org
// WWW       : http://www.kuato.org/
// LICENSE   : GPL vs2.0 [ see /docs/COPYING ] 
//
//-------------------------------------------------------------

define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.'.$phpEx);
include_once($phpbb_root_path . 'mutant_includes/mutant_functions.'.$phpEx);
include_once($phpbb_root_path . 'mutant_includes/class.config.'.$phpEx);
include_once($phpbb_root_path . 'mutant_includes/class.mutant_forum_tree.'.$phpEx);

// Turn on all errors for now
error_reporting(E_ALL);

// Begin portal data structures
// These are just temporary and will be part of the portal database when
// this portal is ready to be released
$module_array = array
(
	'mutant_mainmenu' => array('./mutant_modules/core/', 'mutant_mainmenu.php'),
	'mutant_online' => array('./mutant_modules/core/', 'mutant_online.php'),
	'mutant_welcome' => array('./mutant_modules/core/', 'mutant_welcome.php'),
	'mutant_news' => array('./mutant_modules/core/', 'mutant_news.php'),
	'mutant_articles' => array('./mutant_modules/core/', 'mutant_articles.php'),
	'mutant_latest_posts' => array('./mutant_modules/core/', 'mutant_latest_posts.php'),
	'mutant_poll' => array('./mutant_modules/core/', 'mutant_poll.php'),
	'mutant_downloads' => array('./mutant_modules/core/', 'mutant_downloads.php'),
	'mutant_top_posters' => array('./mutant_modules/core/', 'mutant_top_posters.php'),
	'mutant_rss' => array('./mutant_modules/rss/', 'rss.php')
);

/*
$page_array[0]['name'] = 'Home';
$page_array[0]['data'] = array('x,'y', 'modlist' => array('1') );
*/

$page_array = array
(
	'home' =>array('name' => 'Home', 
		'modinfo' => array ('./', 'mutant_index_body_portal.html', 
			'modlist' => array(	'mutant_mainmenu', 
								'mutant_online',
								'mutant_welcome', 
								'mutant_downloads',
								'mutant_news',
								'mutant_latest_posts',
								'mutant_poll',
								'mutant_top_posters',
					))),
	'about' =>array('name' => 'About',
		'modinfo' => array('./', 'mutant_about_body.html',
			'modlist' => array(	'mutant_mainmenu', 
								'mutant_online',		
								'mutant_news'
					))),
	'articles' =>array('name' => 'Articles',
		'modinfo' => array('./', 'mutant_articles_body.html',
			'modlist' => array(	'mutant_mainmenu', 
								'mutant_online',		
								'mutant_articles'
					))),
	'news_archives' =>array('name' => 'News Archives',
		'modinfo' => array('./', 'mutant_newsarchives_body.html',
			'modlist' => array(	'mutant_mainmenu', 
								'mutant_online',		
								'mutant_news'
					)))
);
// end portal data structures

// Start session management. We are basically using phpbb's session
// library along with their database layer and templating sytem. No need
// to reinvent the wheel :)
$user->start();
$auth->acl($user->data);
$user->setup();

// Assign index specific vars
$template->assign_vars (array(
	'S_LOGIN_ACTION'			=> "ucp.php?$SID&amp;mode=login", 
	'U_MARK_FORUMS' => "index.$phpEx$SID&amp;mark=forums")
);

// Output page
page_header($user->lang['INDEX']);

// Start portal logic
include("mutant_config.php");

// Get the configuration singleton
$mutcfg =& MutantConfig::getInstance();

define('IN_PORTAL', 1);

// Read portal modules language file
$module_root_path = "./mutant_modules/core/";
if ( !file_exists($module_root_path . 'language/' . $config['default_lang'] . '/lang_main.'.$phpEx) )
{
	include($module_root_path . 'language/en/lang_main' . $phpEx);
}
else
{
	include($module_root_path . 'language/'. $config['default_lang'] .  '/lang_main.'. $phpEx);
}

if( !isset($_GET['page']) )
{
	$page = 'home';
}
else
{
	$page = $_GET['page'];
}
$template_file = $page_array[$page]['modinfo'][1];

$template->set_filenames(array(
	'body' => $template_file)
);

// Assign global vars to all modules. These can be overridden
// when the module is called in the code below
$w3c_img = '<a href="http://validator.w3.org/check/referer"><img
          src="mutant_images/valid-xhtml10.gif"
          alt="Valid XHTML 1.0!" height="31" width="88" border="0" /></a>';
$template->assign_vars (array(
	'U_INDEX'				=> 'mutant.'.$phpEx.$SID,
	'L_INDEX'				=> 'Portal Home',
	'MUT_BLOCK_SIZE' 		=> "100%",
	'MUT_BLOCK_CELLPADDING' => "4",
	'MUT_BLOCK_CELLSPACING' => "1",
	'MUT_BLOCK_BORDER' 		=> "0",
	'MUT_BLOCK_CLASS' 		=> "blockborder",
	'MUTANT_NOWRAP'			=> true,
	'MUT_W3C_IMG'			=> $w3c_img,
	'MUT_VERSION' 			=> 'Mutant Portal ' . $mutcfg->get('version') . " &copy; kuato.org 2002-2004"
));

// Now call each module
foreach($page_array[$page]['modinfo']['modlist'] as $key => $value)
{
	$module_root_path = $module_array[$value][0];
	$block_file = $module_root_path . $module_array[$value][1];
	include( $phpbb_root_path . $block_file );
}

// Update navlink at top
if( !empty($page) )
{
	$template->assign_block_vars('navlinks', array(
		'FORUM_NAME'  	=>  $page_array[$page]['name'],
		'U_VIEW_FORUM'  =>  ""
	));
}

// End portal logic

page_footer();

?>
