<?php

//-------------------------------------------------------------
//
// $Id: mutant_latest_posts.php,v 1.10 2004/04/04 03:07:02 kuatodotorg Exp $
//
// STARTED   : 02/04/2004
// COPYRIGHT : 2002-2004 kuato.org
// WWW       : http://www.kuato.org/
// LICENSE   : GPL vs2.0 [ see /docs/COPYING ] 
//
// CREDITS   : While modified and simplified much of the inspiration came from
//			   Mx-System's mx_last_msg.php
//              
//-------------------------------------------------------------

// Get our module config variables
$limit 		= $mutcfg->get('latest_posts_limit');
$forum_list = $mutcfg->get('latest_posts_forum');
$tease_len 	= $mutcfg->get('latest_posts_tease_len');
$display_author 	= $mutcfg->get('display_author');
$display_last_author= $mutcfg->get('display_last_author');
$display_date 		=  $mutcfg->get('display_date');
$display_forum 		=  $mutcfg->get('display_forum');
$display_icon_view 	=  $mutcfg->get('display_icon_view');

$title    = $lang[LATEST_POSTS];
$template->assign_vars(array(
	'L_MUT_LP_TITLE' 		=> $title
));

if( empty($forum_list) )
{
    return;
}

// TODO: Have to fix tracking topics and handle it to use from DB if DB tracking 
$tracking_topics = (isset($_COOKIE[$config['cookie_name'] . '_track'])) ? unserialize(stripslashes($_COOKIE[$config['cookie_name'] . '_track'])) : array();

// Fetch the posts
$sql = 'SELECT 	
			f.forum_name, f.forum_id, 
			t.topic_title, t.topic_last_post_id, 
				t.topic_last_poster_id, t.topic_last_poster_name,
			p.topic_id, p.post_username, p.post_time,
			u.username, u.user_id
		FROM	
			'.FORUMS_TABLE.' f 
		INNER JOIN	
			'.TOPICS_TABLE.' t 
			ON f.forum_id = t.forum_id	
		INNER JOIN  
			'.POSTS_TABLE. ' p  
			ON t.topic_last_post_id = p.post_id
		INNER JOIN	
			'.USERS_TABLE. ' u  
			ON t.topic_poster = u.user_id
		WHERE	t.topic_moved_id = 0 
			AND	t.topic_approved = 1
			AND	f.forum_id IN (' . $forum_list . ")
		ORDER BY 
				t.topic_last_post_id DESC ";
if( !($result = $db->sql_query_limit($sql, $limit, 0)) )
{
	return;
}

// Process the post rows
while( $row = $db->sql_fetchrow($result) ) 
{
	$forum_id =  $row['forum_id'];
	$topic_id =  $row['topic_id'];
	$topic_id36 = base_convert($topic_id, 10, 36);
	$forum_id36 = ($row['topic_type'] == POST_GLOBAL) ? 0 : $row['forum_id'];

	$mark_time_topic = (isset($tracking_topics[$forum_id36][$topic_id36])) ? base_convert($tracking_topics[$forum_id36][$topic_id36], 36, 10) + $config['board_startdate'] : 0;

	if(!$auth->acl_get('f_read', $forum_id))
	{
		// TODO: If not authorized to read this forum then skip it
	}

	$message = $row['topic_title'];

	$url = "viewtopic.$phpEx$SID&amp;t=" .$row['topic_id'].'#'.$row['topic_last_post_id'];

	if( $user->data['user_id'] != ANONYMOUS )
	{
		// todo: call routine to compute appropriate folder	
	}

	if( $display_author == true )
	{
		$topic_author  = ( $row['user_id'] != ANONYMOUS ) ? '<a href="' . "memberlist.$phpEx$SID&amp;mode=viewprofile&amp;" . 'u=' . $row['user_id']. '">' : '';
		$topic_author .= ( $row['user_id'] != ANONYMOUS ) ? $row['username'] : ( ( $row['post_username'] != '' ) ? $row['post_username'] : $user->lang['GUEST'] );
		$topic_author .= ( $row['user_id'] != ANONYMOUS ) ? '</a>' : '';
	}

	if($display_last_author == true)
	{
		$last_post_author = ($row['topic_last_poster_id'] == ANONYMOUS) ? (($row['topic_last_poster_name'] != '') ? $row['topic_last_poster_name'] . ' ' : $user->lang['GUEST'] . ' ') : "<a href=\"memberlist.$phpEx$SID&amp;mode=viewprofile&amp;u="  . $row['topic_last_poster_id'] . '">' . $row['topic_last_poster_name'] . '</a>';
		$topic_author = $last_post_author;
	}

	// Limit message length, user can click on it to read the whole thing
	$message_title = "";
	if( strlen($message ) > $tease_len ) 
	{ 
		$message_title = $message;
		$message = mutant_chop_message($message, $tease_len);
		$message  .= "..."; 
	} 

	if( $display_date == true )
	{
		$message_date = $user->format_date($row['post_time']);
	}

	if( $display_forum == true )
	{
		$forum_name = $row['forum_name'];
		$forum_url  = "viewforum.$phpEx$SID&amp;f=" . $row['forum_id'];
	}

	// create the correct folder icon(read, unread) based on cookie data
	if( $row['post_time'] > $user->data['user_lastvisit'] )
	{
		if( !empty($tracking_topics) )
		{
			$unread_topics = true;
		}

		if( !empty($tracking_topics[$row['topic_id']]) )
		{
			if( $tracking_topics[$row['topic_id']] >= $row['post_time'] )
			{
				$unread_topics = false;
			}
		}
	}
	else
	{
		$unread_topics = false;
	}

	if( $unread_topics )
	{
		$folder_img = $user->img('folder_new', 'NEW_POSTS');
	}
	else
	{
		$folder_img = $user->img('folder', 'NO_NEW_POSTS');
	}

	if( $display_icon_view == true )
	{
		$last_post_url = '<a href="' . "viewtopic.$phpEx$SID&amp;p=" . $row['topic_last_post_id'] . '#' . $row['topic_last_post_id'] . '"><img src="' . $user->img['icon_latest_reply'] . '" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" border="0" />'. $folder_img . '</a>';
	}
	else
	{
		$last_post_url = "";
	}

	$template->assign_block_vars("mut_msg_row", array(
		'POST_MSG'      => $message,
		'POST_MSG_DATE' => $message_date,
		'MESSAGE_TITLE' => $message_title,
		'FORUM_NAME'    => $forum_name,
		'U_POST_MSG'    => $url,
		'U_FORUM'       => $forum_url ,
		'LAST_POST_IMG' => $last_post_url,
		'TOPIC_AUTHOR'  => $topic_author, 
		'L_TOPIC_FOLDER_ALT' => $folder_alt
	));
}
 
?>
